  @echo off
setlocal enabledelayedexpansion enableextensions

rem


:CHECKHELP
	set bat_vers=1.0

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	
	
	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	!bat_pushlog!
	
	set bat_returncode=0
	call :PARSEARGS %*
goto :MAIN %*


:PARSEARGS
!bat_pushlog! [CALL :PARSEARGS %*]
!bat_echolog! '     :PARSEARGS %1, %~dp1, %~nx1

	set bat_yesno=
	if /i "%~1" equ "-y" (
		set bat_yesno=-y
		shift
		!bat_echolog! -y detected
	)

	set bat_output=
	if /i "%~1" equ "-output" (
		set bat_output=%~2
		!bat_echolog! -output detected
		shift
		shift
	)

	set bat_dest=%~1
	if /i "%~2" equ "" (
		set bat_src=*.*
	) else (
		set bat_src=%~2
	)

	
!bat_poplog! [return-:PARSEARGS] [bat_yesno=!bat_yesno!, zip="!bat_dest!", src="!bat_src!"]
!bat_log!
!bat_return!



REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================

:MAIN
!bat_pushlog! [GOTO :MAIN %*]
	echo  ....call "!bat_exedir!\7za.exe" x -tzip -r !bat_yesno! -o"!bat_output!" "!bat_dest!" "!bat_src!"
              call "!bat_exedir!\7za.exe" x -tzip -r !bat_yesno! -o"!bat_output!" "!bat_dest!" "!bat_src!"
rem	          call 7za.exe x -tzip -r !bat_yesno! -o"!bat_output!" "test.zip" "*.log"
	set bat_returncode=!errorlevel!
	!bat_log! set bat_returncode=!bat_returncode!

	!bat_poplog! ENDLOCAL bat_returncode=!bat_returncode!
	( ENDLOCAL & REM RETURN VALUES
		set bat_returncode=%bat_returncode%
	)
!bat_log! exit /b !bat_returncode!
exit /b !bat_returncode!
goto :DONE








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 [-y] "target zip file" "source file spec"
	echo.
	echo Uses 7za.exe command line utility to unzip the files from the specified 
	echo zip file.
	echo.
	echo The optional -y command line option causes it to answer Y to overwrite questions. 
	echo.
	echo.
	echo Example:
	echo        %~nx0 "test.zip" "test*.*"
	echo.
	call 7za.exe -h
exit /b 9

7-Zip (A) 9.20  Copyright (c) 1999-2010 Igor Pavlov  2010-11-18


:DONE
	!bat_poplog! Done with %0 %*
	!bat_log!