  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 08/03/2012:
		
	
	rem 	SplitDetect "C:\CAMS\ArchivedFiles\FTPdetectinfo_09980999_2012_08_03.txt"
	
:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_ECHOONLY=call :ECHOONLY
	set BAT_LOG=call :LOG
	set BAT_ECHO=call :ECHOONLY

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	SET bat_returncode=0
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_logfile=!bat_exedir!\Logs\SplitDetect.bat.log
	set bat_splitdetecttemp=!bat_exedir!\Logs\SplitDetectFiles.bat.txt
	set bat_splitdetecttemp2=!bat_exedir!\Logs\SplitDetectFiles2.bat.txt
	
	
	%bat_echolog% =============================================================...
	%bat_echolog% [%date% %time%] - %~dpnx0 %*
	%bat_echolog% Version: !bat_vers!

	set bat_returncode=0
	call :PARSEARGS %*

goto :MAIN

	
:PARSEARGS [in=%*]
!bat_echolog! call :PARSEARGS %*

	if /i "%~1" equ "" goto :HELP
	
	set bat_detectfilefull=%~1
	set bat_detectfile=%~nx1
	
	set bat_detectdir=%~dp1::
	set bat_detectdir=!bat_detectdir:\::=!
	set bat_detectdir=!bat_detectdir:::=!
	
	set bat_temp_yyyy=!bat_detectfile:~19,4!
	set bat_temp_mm=!bat_detectfile:~24,2!
	set bat_temp_dd=!bat_detectfile:~27,2!
	set bat_captureddate=!bat_temp_yyyy!_!bat_temp_mm!_!bat_temp_dd!
	set bat_sourcedate=!bat_captureddate!
	
	set bat_cameralist=!bat_detectfile:~14,8!
	set bat_cameraA=!bat_cameralist:~1,3!
	set bat_cameraB=!bat_cameralist:~5,3!
	echo !bat_cameraA!>"!bat_splitdetecttemp!"
	echo !bat_cameraB!>>"!bat_splitdetecttemp!"
	set bat_cameraA=
	set bat_cameraB=
	
	for /f "usebackq tokens=*" %%a in (`type "!bat_splitdetecttemp!"^|sort`) do (
		if not defined bat_cameraA (
			set bat_cameraA=%%a
		) else (
			set bat_cameraB=%%a
		)
	)
	
	del /q "!bat_splitdetecttemp!"

	set bat_caldir=!bat_startlocation!\Cal
	
	
	rem What you need to know is that the first camera keeps the original date/time
	rem CapturedFile name and the second camera uses 61 seconds as the last two digits.
	call :GETPARENTDIR "!bat_detectdir!"
	set bat_parentdir=!bat_retval!
	set bat_dirdate=!bat_retval2!


	set bat_detectAname=FTPdetectinfo_0!bat_cameraA!_!bat_dirdate!
	set bat_detectA=!bat_detectAname!.txt
	set bat_detectAdir=!bat_detectdir!
	set bat_detectAfull=!bat_detectdir!\!bat_detectA!
	
	set bat_detectBname=FTPdetectinfo_0!bat_cameraB!_!bat_dirdate!
	set bat_detectB=!bat_detectBname!.txt
	set bat_detectBdir=!bat_parentdir!\!bat_dirdate:~0,17!61
	set bat_detectBfull=!bat_detectBdir!\!bat_detectB!

	call :GETPARENTDIR "!bat_parentdir!"
	set bat_basedir=!bat_retval!
	set bat_captured_dirdate=%~nx2
	set bat_captureddir=%~dp2::
	set bat_captureddir=!bat_captureddir:\::=!
	set bat_captureddir=!bat_captureddir:::=!
	set bat_capturedfilesdirA=!bat_captureddir!\!bat_captured_dirdate!
	set bat_capturedfilesdirB=!bat_captureddir!\!bat_captured_dirdate:~0,17!61

!bat_echolog! return-:PARSEARGS [bat_captureddate=!bat_captureddate!]
%return%




:GETPARENTDIR
	set bat_retval=%~dp1::
	set bat_retval=!bat_retval:\::=!
	set bat_retval=!bat_retval:::=!
	set bat_retval2=%~nx1
!BAT_RETURN!


:MAIN
!bat_echolog! goto :MAIN %*

	if not exist "!bat_detectfilefull!" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    ERROR - Does not exist:
		!bat_echolog! '            "!bat_detectfilefull!"
		!bat_echolog!
		!bat_echolog!
		goto :MAIN_END
	)

	if not exist "!bat_detectBdir!" (
		!bat_echolog! '    md "!bat_detectBdir!"
		                   md "!bat_detectBdir!"
	)

	set bat_sourcefile=!bat_detectfilefull!
	set bat_targetfile=!bat_detectAfull!
	set bat_camera=!bat_cameraA!
	set bat_caseheaderfile=!bat_detectAdir!\header.txt
	
	call :STRIPHEADERS "!bat_sourcefile!" "!bat_targetfile!" "!bat_camera!"

	set bat_countdest=000000!bat_countdest!	
	set bat_countdest=!bat_countdest:~-6!
	call :REBUILDHEADER "!bat_fffoldersrc!" "!bat_detectAdir!" "!bat_countsrc!" "!bat_countdest!"

	set bat_string="!bat_detectAdir!\!bat_temp_targetfilename!"
	call :CONCATFINAL "!bat_detectAdir!" "!bat_detectA!" "!bat_detectAfull!" "!bat_capturedfilesdirA!"
	
	set bat_sourcefile=!bat_detectfilefull!
	set bat_targetfile=!bat_detectBfull!
	set bat_camera=!bat_cameraB!
	set bat_caseheaderfile=!bat_detectBdir!\header.txt

	call :STRIPHEADERS "!bat_sourcefile!" "!bat_targetfile!" "!bat_camera!"


	set bat_countdest=000000!bat_countdest!
	set bat_countdest=!bat_countdest:~-6!
	call :REBUILDHEADER "!bat_fffoldersrc!" "!bat_detectBdir!" "!bat_countsrc!" "!bat_countdest!"

	set bat_string="!bat_detectBdir!\!bat_temp_targetfilename!"
	call :CONCATFINAL "!bat_detectBdir!" "!bat_detectB!" "!bat_detectBfull!" "!bat_cameraB!" "!bat_capturedfilesdirB!"
	
goto :MAIN_END


	!bat_echolog!
	!bat_echolog! '    call "MergeDetectFiles.bat" "!bat_sourcedir!" "!bat_targetdir!" "FTPdetectinfo_0*.txt" "!bat_captureddate!" "!bat_sourcedate!"
	                   call "MergeDetectFiles.bat" "!bat_sourcedir!" "!bat_targetdir!" "FTPdetectinfo_0*.txt" "!bat_captureddate!" "!bat_sourcedate!"
	!bat_echolog! '    Returned from MergeDetectFiles.bat... ending... %*

	if exist "!bat_targetfilefull!" (
		if /i "!bat_targetfilefull!" neq "!bat_sourcedir!\!bat_targetname!" (
			!bat_echolog! '    copy /y "!bat_targetfilefull!" "!bat_sourcedir!"
							   copy /y "!bat_targetfilefull!" "!bat_sourcedir!"
		)
		
		call :FIXFFFOLDER "!bat_targetfilefull!" "!bat_sourcedir!"
	)
	
	if "!bat_sourcedir!" neq "!bat_targetdir!" (
		!bat_echolog! '    del /q "!bat_targetdir!"
		                   del /q "!bat_targetdir!"

		!bat_echolog! '    rd /q "!bat_targetdir!"
		                   rd /q "!bat_targetdir!"
	)

:MAIN_END
!bat_echolog! end of :MAIN %*
goto :DONE







:STRIPHEADERS
!bat_echolog! call :STRIPHEADERS [%*]
	set bat_temp_sourcefilefull=%~1
	set bat_temp_targetfilefull=%~2
	set bat_temp_camera=%~3
	
	set bat_temp_sourcefilename=%~nx1
	set bat_temp_sourcedir=%~dp1::
	set bat_temp_sourcedir=!bat_temp_sourcedir:\::=!
	set bat_temp_sourcedir=!bat_temp_sourcedir:::=!
	
	
	set bat_temp_targetfilename=FTPdetectinfo_0!bat_temp_camera!_stripped.txt
	set bat_temp_targetdir=%~dp2::
	set bat_temp_targetdir=!bat_temp_targetdir:\::=!
	set bat_temp_targetdir=!bat_temp_targetdir:::=!

	if exist "!bat_temp_targetfile!" (
		del /q "!bat_temp_targetfile!"
	)
	
	if exist "!bat_temp_targetdir!\!bat_temp_targetfilename!" (
		del /q "!bat_temp_targetdir!\!bat_temp_targetfilename!"
	)
	
	if exist "!bat_caseheaderfile!" (
		del /q "!bat_caseheaderfile!"
	)
	
	set /a bat_count_line=0
	set /a bat_count_seg=false
	set /a bat_countdest=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_temp_sourcedir!\!bat_temp_sourcefilename!"`) do (
		set /a bat_count_line+=1
		set bat_temp=%%a

		if !bat_count_line! LEQ 11 (
			echo %%a>>"!bat_caseheaderfile!"

			if !bat_count_line! equ 1 (
				set bat_countsrc=!bat_temp:~-6!
			) else (

				if !bat_count_line! equ 5 (
					set bat_fffoldersrc=!bat_temp:~13,200!
				) else (

					if !bat_count_line! equ 6 (
						set bat_calfoldersrc=!bat_temp:~13,200!
					)
				)
			)
		) else (
			set /a bat_count_seg+=1
			if /i "%%a" equ "-------------------------------------------------------" (
				set /a bat_count_seg=-3
				set /a bat_seg_total=0
				set bat_cam_match=false
			) else (
				if !bat_count_seg! equ -2 (
					set bat_FF=%%a
					set bat_FFcam=!bat_FF:~2,3!
					if /i "!bat_FFcam!" equ "!bat_temp_camera!" (
						set bat_cam_match=true
						set /a bat_countdest+=1
						echo ------------------------------------------------------->>"!bat_temp_targetdir!\!bat_temp_targetfilename!"
						rem move /y "!bat_temp_sourcedir!\!bat_FF!" "!bat_temp_targetdir!"
					)
				)
				
				if /i "!bat_cam_match!" equ "true" (
					if !bat_count_seg! equ 0 (
						for /f "tokens=1-3" %%b in ("%%a") do (
							set bat_seg_total=%%d
							call :STRIPZEROS %%d bat_seg_total

							echo %%a>>"!bat_temp_targetdir!\!bat_temp_targetfilename!"
						)
					) else (
						echo %%a>>"!bat_temp_targetdir!\!bat_temp_targetfilename!"
					)
				)
				
			)
		)
	)
	
	goto :STRIPHEADERS_END
	
	echo '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_temp_sourcedir!\!bat_temp_sourcefilename!" /b /a-d /on`^) do ^(
	for           /f "usebackq tokens=*" %%a in  (`dir "!bat_temp_sourcedir!\!bat_temp_sourcefilename!" /b /a-d /on`) do (
		set bat_temp_filename=%%~nxa
		set bat_temp_fullfilename_src=!bat_temp_sourcedir!\!bat_temp_filename!
		set bat_temp_fullfilename_tar=!bat_temp_targetdir!\!bat_temp_targetfilename!
		set bat_temp_headerfull=!bat_temp_targetdir!\header.txt

		if /i "!bat_temp_filename!" neq "FTPdetectinfo.txt" (
			if /i "!bat_temp_filename!" neq "!bat_targetname!" (
				if /i "!bat_temp_filename:~-13!" neq "_stripped.txt" (
					if /i "!bat_temp_filename!" neq "FTPdetectinfo_CaseHeader.txt" (
						!bat_echolog! '    call "!bat_exedir!\StripHeaderNASA.bat" "!bat_temp_fullfilename_src!" "!bat_temp_headerfull!" "!bat_temp_targetdir!\!bat_temp_targetfilename!"
					                      call "!bat_exedir!\StripHeaderNASA.bat" "!bat_temp_fullfilename_src!" "!bat_temp_headerfull!" "!bat_temp_targetdir!\!bat_temp_targetfilename!"
					)
				)
			)
		)
	)


:STRIPHEADERS_END
!bat_return!



:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
:STRIPZEROS_END
EXIT /b
!bat_return!






	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
	rem		IN	"!bat_fffoldersrc!"
	rem		IN	"!bat_detect?dir!"
	rem		IN	"!bat_countsrc!"
	rem		IN	"!bat_countdest!"
:REBUILDHEADER
!bat_echolog! call :REBUILDHEADER %*
setlocal enabledelayedexpansion enableextensions
	set bat_fffoldersrc=%~1
	set bat_targetdir=%~2
	set bat_countsrc=%~3
	set bat_countdest=%~4

	set bat_findstr=!bat_fffoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=FF  folder = !bat_targetdir!\
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	set bat_findstr_c=!bat_countsrc!

	set bat_replstr_c=!bat_countdest!

	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	set bat_findstr=!bat_calfoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=CAL folder = !bat_caldir!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	echo.
	echo.
	echo  type "!bat_caseheaderfile!"
	echo.
	for /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"`) do (
		echo     %%~a
	)
	echo.
	echo.
!bat_echolog! return-:REBUILDHEADER [see output above from the command: type "!bat_caseheaderfile!"]
endlocal
%bat_return%






:CONCATFINAL
!bat_echolog! call :CONCATFINAL [%*]
	set bat_targetdir=%~1
	set bat_targetname=%~2
	set bat_targetfilefull=%~3
	set bat_temp_camera=%~4
	set bat_temp_captureddir=%~5

	echo     copy /y /b "!bat_caseheaderfile!"+!bat_string! "!bat_targetdir!\!bat_targetname!"
	         copy /y /b "!bat_caseheaderfile!"+!bat_string! "!bat_targetdir!\!bat_targetname!"

	echo '    del "!bat_caseheaderfile!"
	          del "!bat_caseheaderfile!"
	echo '    del "!bat_targetdir!\!bat_temp_targetfilename!"
	          del "!bat_targetdir!\!bat_temp_targetfilename!"
	          
	if /i "!bat_targetdir!" neq "!bat_detectdir!" (
		!bat_echolog! '    move /y "!bat_detectdir!\FF!bat_temp_camera!_*.bin" "!bat_targetdir!"
		                   move /y "!bat_detectdir!\FF!bat_temp_camera!_*.bin" "!bat_targetdir!"

		!bat_echolog! '    copy /y "!bat_detectdir!\CameraTimeOffsets.txt" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\CameraTimeOffsets.txt" "!bat_targetdir!"

		!bat_echolog! '    copy /y "!bat_detectdir!\CaptureStats.log" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\CaptureStats.log" "!bat_targetdir!"

		!bat_echolog! '    copy /y "!bat_detectdir!\ReprocessParameters.txt" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\ReprocessParameters.txt" "!bat_targetdir!"

		!bat_echolog! '    copy /y "!bat_detectdir!\LASTSETTINGS.txt" "!bat_targetdir!"
		                   copy /y "!bat_detectdir!\LASTSETTINGS.txt" "!bat_targetdir!"

		if not exist "!bat_temp_captureddir!" (
			md "!bat_temp_captureddir!"
		)
		
		!bat_echolog! '    move /y "!bat_capturedfilesdirA!\FF!bat_temp_camera!_*.bin" "!bat_temp_captureddir!"
		                   move /y "!bat_capturedfilesdirA!\FF!bat_temp_camera!_*.bin" "!bat_temp_captureddir!"
	)
	
set bat_

	echo.
	if not exist "!bat_targetfilefull!" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command:
		echo    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE
:CONCATFINAL_END
!bat_echolog! return-:CONCATFINAL ["!bat_targetfilefull!"]
%bat_return%






















































	rem This routine puts a header file into the targetdir. If it can't copy one from 
	rem C:\CAMS, it creates a new one.
:CREATECASEHEADER
!bat_echolog! call :CREATECASEHEADER %*

	if exist "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" (
		echo '    copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
		          copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
	) else (
		echo Meteor Count = 000000>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Processed with FTP 1.3 on Tue Feb 28 00:00:00 2012>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  folder = c:\d\CAMS\ArchivedFiles\2011_12_29_10_05_22\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL folder = c:\d\CAMS\Cal\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Cam# Meteor# #Segments fps hnr mle bin Pix/fm Rho Phi>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Per segment:  Frame# Col Row RA Dec Azim Elev Inten>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"

	)
!bat_echolog! return-:CREATECASEHEADER ["!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"]
!bat_return!






		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"

		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)
	
	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	set bat_calfolder=!bat_targetdir!\Cal

	rem convert bat_fffoldersrc to C-style string
	set bat_fffoldersrc_c=!bat_fffoldersrc:\=\\!
	set bat_fffoldersrc_c=!bat_fffoldersrc_c::=\:!
	
	set bat_fffolderdest=!bat_targetdir!\ArchivedFiles\
	set bat_fffolderdest_c=!bat_fffolderdest:\=\\!
	set bat_fffolderdest_c=!bat_fffolderdest_c::=\\!

	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iC "!bat_targetdir!\!bat_detectfile!" "!bat_fffoldersrc_c!" "!bat_fffolderdest_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iC "!bat_targetdir!\!bat_detectfile!" "!bat_fffoldersrc_c!" "!bat_fffolderdest_c!"


	!bat_echolog! '    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!

	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS [!bat_recent_error_msg!]
!bat_return!



	rem temporary concat to fix the meteor count
	rem This section concats without the header
	rem Result: New "FTPdetectinfo.txt" file n the target dir.
:TEMPCONCAT
!bat_echolog! call :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetdir!\!bat_sourcefilespecname!_stripped.txt" /b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetdir!\!bat_sourcefilespecname!_stripped.txt" /b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%bat_targetdir%\%%~a"
		) else (
			set bat_string=!bat_string!+"%bat_targetdir%\%%~a"
		)
	)
	!bat_echolog! '    copy /y /b !bat_string! "!bat_targetdir!\!bat_targetname!"
	                   copy /y /b !bat_string! "!bat_targetdir!\!bat_targetname!"

	set bat_caseheaderfile=!bat_targetdir!\FTPdetectinfo_CaseHeader.txt

!bat_echolog! return-:TEMPCONCAT [!bat_string!]
%bat_return%




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT [out=bat_count]
!bat_echolog! call :GETMETEORCOUNT %*
	if not exist "!bat_targetdir!\!bat_targetname!" (
		!bat_echolog! '    ERROR - file not found: "!bat_targetdir!\!bat_targetname!"
		set bat_returncode=1
		goto :ABORT
	)
	
	
	!bat_echoonly! '    for /f "usebackq tokens=1-4" ..a in ^(`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`^) do ^(
	for                     /f "usebackq tokens=1-4" %%a in  (`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`) do (
		!bat_echoonly! '    set bat_count=%%c
		                    set bat_count=%%c
	)

	!bat_echoonly! '    for /f "usebackq tokens=*" a in ^(`type "!bat_caseheaderfile!" find /i "Meteor Count = "`^) do ^(
	for                     /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"^|find /i "Meteor Count = "`) do (
		!bat_echoonly! '    set bat_countsrc=%%a
		                    set bat_countsrc=%%a
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
	set bat_countdest=Meteor Count = !bat_count!


!bat_echolog! return-:GETMETEORCOUNT [!bat_countdest!]
%bat_return%



:FIXFFFOLDER [out=bat_fffoldersrc]
!bat_echolog! call :FIXFFFOLDER %*
	set bat_fffoldersrc=
	!bat_echoonly! '    for /f "usebackq tokens=* skip=2"   a in ^(`find /i "FF  folder = " "!bat_sourcedir!\!bat_targetname!"`^) do ^(
	                    for /f "usebackq tokens=* skip=2" %%a in  (`find /i "FF  folder = " "!bat_sourcedir!\!bat_targetname!"`) do (
		set bat_fffoldersrc=%%a
	)
	
	!bat_echolog! '    bat_fffoldersrc=!bat_fffoldersrc!
	
	if not defined bat_fffoldersrc (
		goto :FIXFFFOLDER_END
	)
	
	set bat_findstr=!bat_fffoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=FF  folder = !bat_sourcedir!\
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	set bat_detectfile=!bat_sourcedir!\!bat_targetname!
	
	
	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_detectfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_detectfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	
:FIXFFFOLDER_END
!bat_echolog! return-:FIXFFFOLDER ["!bat_fffoldersrc!"]
!bat_return!


:GETCALFOLDER [out=bat_calfoldersrc]
!bat_echolog! call :GETCALFOLDER %*
	!bat_echoonly! '    for /f "usebackq tokens=*" a in ^(`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`^) do ^(
	for                    /f "usebackq tokens=*" %%a in (`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`) do (
		set bat_calfoldersrc=%%a
	)
!bat_echolog! return-:GETCALFOLDER ["!bat_calfoldersrc!"]
!bat_return!






















































:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%


:GETMETEORCOUNTARCHIVED
!bat_echolog! call :GETMETEORCOUNTARCHIVED %*
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
           
		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			
			if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
				set bat_latestcal=
				set /a bat_archivedmeteorcount=0
				
				goto :GETMETEORCOUNTARCHIVED_END
			)
		)
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_echolog! return-:GETMETEORCOUNTARCHIVED [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_archivedfilesdir!\!bat_detectfile!]
%bat_return%




:GETCONFIRMEDCOUNT
!bat_echolog! call :GETCONFIRMEDCOUNT %*
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
				goto :GETCONFIRMEDCOUNT_END
			)
		)
	)


	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)

	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_echolog! return-:GETCONFIRMEDCOUNT [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!, !bat_confirmdetect!]
%bat_return%




:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_echolog! call :GETFILECOUNT "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_echolog! return-:GETFILECOUNT [%~1=!%1!]
%bat_return%



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%






:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%







:VARIABLES
	set bat_
	pause
%return%


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)

	!bat_echolog! '    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!
	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS [!bat_recent_error_msg!]
!bat_return!




:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%


:ECHOONLY
	rem Echo to the console
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "<detect file>" "<capture dir>"
	echo.
	echo Example: 
	echo   splitdetect "c:\CAMS\ArchivedFiles\2012_07_14_05_12_29\FTPdetectinfo_02160213_2012_07_14.txt" "C:\CAMS\CapturedFiles\2012_07_14_04_34_59"
	echo.
	echo Generates two separate detect files, one for each camera in the detect file. 
	echo.
	echo Then it does the following:
	echo   1. Creates a directory for the highest camera number in the camera list
	echo   2. Moves all the camera files matching the highest camera number to the
	echo      new directory
	echo   3. Leaves the files pertaining to the lowest camera number in the 
	echo      original directory.
	echo.
	echo.
	echo.
exit /b 9

Needs:
	- 
	
:ABORT
	!bat_echolog! '    ABORTING
	!bat_echolog! '    bat_returncode=!bat_returncode!
	pause
exit /b !bat_returncode!

:DONE
	rem call :SAVECONFIG
	echo.
	echo Done with %0 %*
	echo.
exit /b !bat_returncode!