@echo off
setlocal enabledelayedexpansion enableextensions

rem RENAME THIS FILE TO ...
rem

:SETUP
	setlocal enableextensions enabledelayedexpansion

	if "%1" equ "" goto :HELP

	set bat_targetlocation=%cd%
	set bat_targetdrive=%cd:~0,2%
	set bat_targetdirfull=%~1

	if "%2" neq "" set bat_targetdrive=%~2

	set bat_

:MAIN
	set /a linecount=0
	rem start the execution of the detection pass in background priority

	echo !date! !time!>fix.ftpdetect.info.log

	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdirfull!\ftpdetectinfo.txt"`) do (
		set bat_temp=%%a
		set bat_title=!bat_temp:~0,2!
		if /i "!bat_title!" equ "FF" (
			title  %%a
		)
		set bat_inputline=%%a
		set bat_outputline=!bat_inputline:C:=%bat_targetdrive%!
		if "!bat_inputline!" neq "!bat_outputline!" (
			echo !bat_inputline!
			echo !bat_outputline!
			echo.
			echo.
		)

		rem title !bat_outputline!
		if !linecount! equ 0 (
			echo !bat_outputline!>"!bat_targetdirfull!\ftpdetectinfo.temp.txt"
			set /a linecount+=1
		) else (
			echo !bat_outputline!>>"!bat_targetdirfull!\ftpdetectinfo.temp.txt"
			set /a linecount+=1
	
		)
	)

	copy /Y "!bat_targetdirfull!\ftpdetectinfo.temp.txt" "!bat_targetdirfull!\ftpdetectinfo.txt"
	del /q "!bat_targetdirfull!\ftpdetectinfo.temp.txt"

exit/b 0

:HELP
	@echo off
	echo.
	echo %0
	echo.
	echo This script changes the drive letter in the FTPdetectinfo.txt files
	echo to the drive letter of the letter specified.
	echo.
	echo
exit /b 9


:DONE
