
@echo off

setlocal enabledelayedexpansion enableextensions

echo.
echo=======================================================================
echo %~f0   version 2.1.0
echo Iterates through subdirs to do "md5check.bat" at each subdir.


if {%1} equ {} (
	set command=md5check /q
	set command2=dir md5.output.txt /s/b
	echo.
	echo Here is the list of md5.output.txt files that will be checked.  
	echo This list of files is obtained by invoking this command^:
	echo   !command2!  
echo.
	echo They will by checked by changing to each file's directory and then 
	echo invoking the "!command!" script in each of the directories listed^: 

echo.
	set md5.junkfile=c:\md5.junk.txt
	call !command2!|sort>!md5.junkfile!
	echo ---------------------
	rem type !md5.junkfile!
	for /F "usebackq delims=<|>" %%a in ("!md5.junkfile!") do (
		echo     %%~fa
	)
	echo ---------------------
) else goto :HELP

set cd_original=!cd!



@echo.

Echo Here is the list of commands that will be executed^:
for /f "usebackq delims=<|>" %%a in ("!md5.junkfile!") do (
	set command3=cd /d "%%~dpa"
	echo !command3!
	call !command3!
	echo !cd!
	echo call !command!
	rem call !command!
)

echo.
echo.
echo Starting the repeating commands...
echo.
echo.
@echo.
@echo     Note: It is safe to interrupt this process at any time.  Errors will be
@echo           logged in "C:\md5check.err.log".
@echo.
@echo           Reading files and computing the hash - please be patient, this can 
@echo           take several minutes for large files... (the caption bar will 
@echo           display the size of the files it is working on)
@echo.

rem goto :DONE


echo.>c:\md5checkRebuildDirs.err.log

for /f "usebackq delims=<|>" %%a in ("!md5.junkfile!") do (
		set command3=cd /d "%%~dpa"
	echo.
	echo.
	echo !command3!
	call !command3!
	echo !cd!
	echo call !command!
	call !command!
	type "C:\md5check.err.log">>"c:\md5checkRebuildDirs.err.log"
	echo.>>"c:\md5checkRebuildDirs.err.log"
)
goto :DONE


:HELP
echo %~f0
echo Batch file that runs md5check.bat repeatedly in the subdirs where it finds md5.output.txt files.
echo.
goto :DONE

:DONE
echo.
echo md5repeatDirs.bat FINISHED
echo md5repeatDirs.bat FINISHED>>"c:\md5checkRebuildDirs.err.log"
type "c:\md5checkRebuildDirs.err.log"
del !md5.junkfile!
cd /d "!cd_original!"


