  @echo off
setlocal enabledelayedexpansion enableextensions
rem


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 04/28/2012:
		
	
	
:SETUP
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	
	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	!bat_pushecho!
	
	set bat_returncode=0


	call :PARSEARGS %*
	if !bat_returncode! neq 0 goto :HELP

goto :MAIN

	
:PARSEARGS
!bat_echolog! call :PARSEARGS %*
	set bat_returncode=0

	if /i "%~1" equ "" (
		set bat_returncode=1
		echo     You must specify a source directory
	)

	set bat_confirmedfilesdir=%~dp1::
	set bat_confirmedfilesdir=!bat_confirmedfilesdir:\::=!
	set bat_confirmedfilesdir=!bat_confirmedfilesdir:::=!
	
	set bat_confirmedmoviesdir=!bat_confirmedfilesdir!\movies
!bat_echolog! return-:PARSEARGS [returncode=!bat_returncode!, "!bat_confirmedfilesdir!"]
!bat_log!
!bat_return!




REM ======================= MAIN ===================================

:MAIN
	if exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
		rem Sort by date and get the newest one
		!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ^(
		for                /f "usebackq tokens=*" %%a in  (`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
			set bat_fffile=%%a
			set bat_fffile2=%%~nxa
			set bat_fffilefull=!bat_confirmedfilesdir!\%%~a
		)
		
		!bat_popecho! !bat_detectfile!, !bat_detectfile2!

		!bat_logexec! start /w "!bat_exedir!\FTP_SingleFFMovie.exe 29.97  !bat_fffilefull!"

		!bat_echolog!
	) else (
		!bat_echolog! '    ERROR - Can't find: "!bat_confirmedfilesdir!\!bat_detectfile!"
	)
	
	if exist "!bat_confirmedmoviesdir!\*.avi" (
		!bat_logexec! call "!bat_exedir!\7zip.bat" "!bat_confirmedfilesdir!\!bat_captureddate!.avi.zip" "!bat_confirmedfilesdir!\*.avi!"
		!bat_echolog!
		!bat_logexec!del /q "!bat_confirmedfilesdir!\*.avi"
	)
goto :DONE












:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<source dir^>"
	echo.
	echo Produces an AVI file based on the specified FF file. 
	echo.
	echo The output is saved in the source directory.
	echo.
	echo.
exit /b 9


:DONE
	!bat_popecho!
	!bat_echolog! Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
